--
-- EmySPC600---
-- Specialization for Emy Ago-Modding 
-- @author Ago-Modding ( www.modhoster.de   FB: www.facebook.com/ago.systemtech );
-- @date          12/01/2015;
---@Edited - fix  Mogli (20/04/16)
-- free for non commerical-usage.
--	@date          02/12/2016;
--- @ fix and convert FS17 Ago-Modding.
Emy = {};

function Emy.prerequisitesPresent(specializations)
    return true;
end;


function Emy:load(savegame)
    self.setAdditional = SpecializationUtil.callSpecializationsFunction("setAdditional");  --extra funzioni---
    -- Animazione Rotazione Rotori --    
    self.animation = {};
    self.animation.animCharSet = 0;
    self.animationEnabled = false;

    local rootNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.animation#rootNode"));

    if rootNode ~= nil then
        self.animation.animCharSet = getAnimCharacterSet(rootNode);
        if self.animation.animCharSet ~= 0 then
            self.animation.clip = getAnimClipIndex(self.animation.animCharSet, getXMLString(self.xmlFile, "vehicle.animation#animationClip"));
            if self.animation.clip >= 0 then
                assignAnimTrackClip(self.animation.animCharSet, 0, self.animation.clip);
                self.animation.speedScale = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.animation#speedScale"), 1);
                setAnimTrackSpeedScale(self.animation.animCharSet, self.animation.clip, self.animation.speedScale);
                setAnimTrackLoopState(self.animation.animCharSet, 0, true);
            end;
        end;
    end;
    self.animationSpeed = 0;
    self.animation.offsetTime = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.animation#offsetTime"), 3) * 1000;
    ----------- Suono Erpice---------
    
    local rotarySound  = getXMLString(self.xmlFile, "vehicle.rotarySound#file");
    if rotarySound  ~= nil and rotarySound  ~= "" then
        rotarySound  = Utils.getFilename(rotarySound, self.baseDirectory);
        self.rotarySoundPitchOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.rotarySound#pitchOffset"), 1.0);
        self.rotarySoundRadius = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.rotarySound#radius"), 50);
        self.rotarySoundInnerRadius = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.rotarySound#innerRadius"), 10);
        self.rotarySoundVolume = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.rotarySound#volume"), 1.0);
        self.rotarySound = createAudioSource("rotarySound", rotarySound, self.rotarySoundRadius, self.rotarySoundInnerRadius, self.rotarySoundVolume, 0);
        link(self.components[1].node, self.rotarySound);
        setVisibility(self.rotarySound, false);
     end;
    
end;

function Emy:delete()
    if self.rotarySound ~= nil then
        delete(self.rotarySound);
        self.rotarySound = nil;
    end;
end;

function Emy:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Emy:keyEvent(unicode, sym, modifier, isDown)
end;
function Emy:readStream(streamId, connection)
end;

function Emy:writeStream(streamId, connection)
end;

function Emy:readUpdateStream(streamId, timestamp, connection)
end;

function Emy:writeUpdateStream(streamId, connection, dirtyMask)
end;

function Emy:update(dt)
    if self:getIsActiveForInput() and self:getToggledFoldDirection() > 0 and self.foldAnimTime == 0 then 
        if InputBinding.hasEvent(InputBinding.PROTEZIONI) then
            if self:getRealAnimationTime("Additional") > 750 then
                self:playAnimation("Additional", -1, nil);
            elseif self:getRealAnimationTime("Additional") < 750 then
                self:playAnimation("Additional", 1, nil);
            end;
        end;
    end;
end;

function Emy:updateTick(dt)
    if self:getIsActive() then
        if self.turnOnVehicle.isTurnedOn then    
            if not self.animationEnabled then
                enableAnimTrack(self.animation.animCharSet, 0);
                self.animationEnabled = true;
            else
                if self.animationSpeed < (self.animation.speedScale - 0.01) then
                    local newSpeed = Utils.getMovedLimitedValues({self.animationSpeed}, {self.animation.speedScale}, {0}, 1, self.animation.offsetTime, dt, false);
                    self.animationSpeed = newSpeed[1];
                    setAnimTrackSpeedScale(self.animation.animCharSet, 0, self.animationSpeed);
                    setVisibility(self.rotarySound, true);
                end;
            end;
    
        else
            if self.animationEnabled then
                if self.animationSpeed < 0.01 then
                    disableAnimTrack(self.animation.animCharSet, 0);
                    self.animationEnabled = false;
                else
                    enableAnimTrack(self.animation.animCharSet, 0);
                    local newSpeed = Utils.getMovedLimitedValues({self.animationSpeed}, {self.animation.speedScale}, {0}, 1, self.animation.offsetTime, dt, true);
                    self.animationSpeed = newSpeed[1];
                    setAnimTrackSpeedScale(self.animation.animCharSet, 0, self.animationSpeed);
                    setVisibility(self.rotarySound, false);
                end;
            end;
        
        end;
    end;

    -- if self.isClient then
        -- setVisibility(self.rotarySound, self.isTurnedOn); 
		
    -- end
end;

function Emy:draw()
        if self:getRealAnimationTime("Additional") > 0 then
            g_currentMission:addHelpButtonText(g_i18n:getText("PROTEZIONI_ON"), InputBinding.PROTEZIONI);
        else
            g_currentMission:addHelpButtonText(g_i18n:getText("PROTEZIONI_OFF"), InputBinding.PROTEZIONI);
        end;
end;

function Emy:onDeactivate()
    if self.animationEnabled then
        disableAnimTrack(self.animation.animCharSet, 0);
        self.animationEnabled = false;
        setVisibility(self.rotarySound, false);
    end;
end;
function Emy:onLeave()
    if self.animationEnabled then
        disableAnimTrack(self.animation.animCharSet, 0);
        self.animationEnabled = false;
    end;
end;

function Emy:onDetach()
    if self.animationEnabled then
        disableAnimTrack(self.animation.animCharSet, 0);
        self.animationEnabled = false;
        setVisibility(self.rotarySound, false);
    end;
end;

function Emy:onAttach()
    if self.animationEnabled then
        disableAnimTrack(self.animation.animCharSet, 0);
        self.animationEnabled = false;
        setVisibility(self.rotarySound, false);
    end;
end;

function Emy:aiTurnOn()
    self.setIsTurnedOn(self, true, true)
end
function Emy:aiTurnOff()
    self.setIsTurnedOn(self, false, true)
end
function Emy:aiLower()
    self.setIsTurnedOn(self, true, true)
end
function Emy:aiRaise()
    self.setIsTurnedOn(self, false, true)
end
